/*
 * Copyright 2007, Axel Dörfler, axeld@pinc-software.de. All Rights Reserved.
 * Distributed under the terms of the MIT License.
 * Many thanks to Axel Dörfler, changed for BCM440x Andreas Benzler 04/2008
 */


#include <sys/bus.h>
#include "if_bfereg.h"

HAIKU_FBSD_DRIVER_GLUE(bcm44x, bfe, pci)

//HAIKU_DRIVER_REQUIREMENTS(0); //FBSD_TASKQUEUES | FBSD_SWI_TASKQUEUE);
HAIKU_DRIVER_REQUIREMENTS(FBSD_TASKQUEUES | FBSD_SWI_TASKQUEUE);
extern driver_t *DRIVER_MODULE_NAME(ukphy, miibus);

driver_t *
__haiku_select_miibus_driver(device_t dev)
{
	driver_t *drivers[] = {
		DRIVER_MODULE_NAME(ukphy, miibus),
		NULL
	};

	return __haiku_probe_miibus(dev, drivers);
}

int
__haiku_disable_interrupts(device_t dev)
{
	struct bfe_softc *sc = device_get_softc(dev);
	u_int32_t status;
	u_int32_t mask;

	HAIKU_INTR_REGISTER_STATE;
	HAIKU_INTR_REGISTER_ENTER();

	status = CSR_READ_4(sc, BFE_ISTAT);

	CSR_READ_4(sc, BFE_ISTAT);

	if (status == 0) {
		HAIKU_INTR_REGISTER_LEAVE();
		return 0;	
	}

	mask = CSR_READ_4(sc, BFE_IMASK);
	status &= mask;
	CSR_WRITE_4(sc, BFE_ISTAT, status);
	HAIKU_INTR_REGISTER_LEAVE();
	
	return status & sc->bfe_imask;
}

void
__haiku_reenable_interrupts(device_t dev)
{
	struct bfe_softc *sc = device_get_softc(dev);
	CSR_WRITE_4(sc, BFE_IMASK, sc->bfe_imask);
//	CSR_WRITE_4(sc, BFE_IMASK, BFE_IMASK_DEF);
}
